Index: plugins/calendar/src/main/java/com/xpn/xwiki/plugin/calendar/CalendarPlugin.java
===================================================================
--- plugins/calendar/src/main/java/com/xpn/xwiki/plugin/calendar/CalendarPlugin.java	(revision 25496)
+++ plugins/calendar/src/main/java/com/xpn/xwiki/plugin/calendar/CalendarPlugin.java	(working copy)
@@ -101,29 +101,29 @@
         return getHTMLCalendar(calendarParams, cData, context);
     }
 
-    public String getHTMLCalendar(CalendarParams calendarParams, XWikiDocument doc, String user,
-        XWikiContext context) throws XWikiException
+    public String getHTMLCalendar(CalendarParams calendarParams, XWikiDocument doc, String user, XWikiContext context)
+        throws XWikiException
     {
         CalendarData cData = new CalendarData(doc, user, context);
         return getHTMLCalendar(calendarParams, cData, context);
     }
 
-    public String getHTMLCalendar(CalendarParams calendarParams, String hql, String user,
-        XWikiContext context) throws XWikiException
+    public String getHTMLCalendar(CalendarParams calendarParams, String hql, String user, XWikiContext context)
+        throws XWikiException
     {
         CalendarData cData = new CalendarData(hql, user, context);
         return getHTMLCalendar(calendarParams, cData, context);
     }
 
-    public String getHTMLCalendar(CalendarParams calendarParams, String hql, int nb,
-        XWikiContext context) throws XWikiException
+    public String getHTMLCalendar(CalendarParams calendarParams, String hql, int nb, XWikiContext context)
+        throws XWikiException
     {
         CalendarData cData = new CalendarData(hql, nb, context);
         return getHTMLCalendar(calendarParams, cData, context);
     }
 
-    public String getHTMLCalendar(CalendarParams calendarParams, CalendarData calendarData,
-        XWikiContext context) throws XWikiException
+    public String getHTMLCalendar(CalendarParams calendarParams, CalendarData calendarData, XWikiContext context)
+        throws XWikiException
     {
         StringBuffer output = new StringBuffer();
         Calendar cal; // For iterating through days of month
@@ -178,6 +178,8 @@
         // --- draw the calendar ---
         // -------------------------
         String tempMonthUrl;
+        String msgPreviousMonth = context.getMessageTool().get("web.paging.previousPage");
+        String msgNextMonth = context.getMessageTool().get("web.paging.nextPage");
 
         output.append("<table summary=\"Event calendar\"");
         output.append(" id=\"wiki-calendar-table-" + id + "\"");
@@ -185,24 +187,22 @@
 
         output.append("<tr class=\"wiki-calendar-month\">");
         if ((tempMonthUrl = calendarParams.computePrevMonthURL(context)) != "") {
-            tempMonthUrl = "<a href=\"" + tempMonthUrl + "\">&lt;</a>";
+            tempMonthUrl = "<a href=\"" + tempMonthUrl + "\">" + msgPreviousMonth + "</a>";
         } else {
-            tempMonthUrl = "<span class=\"disabled\">&lt</span>";
+            tempMonthUrl = "<span class=\"disabled\">" + msgPreviousMonth + "</span>";
         }
-        output.append("<th class=\"wiki-calendar-month-nav prev-month\">" + tempMonthUrl
-            + "</th>");
+        output.append("<th class=\"wiki-calendar-month-nav prev-month\">" + tempMonthUrl + "</th>");
 
         output.append("<th colspan=\"5\" " + "class=\"wiki-calendar-monthyearrow\">");
         output.append(formatTitle.format(dayCal.getTime()));
         output.append("</th>");
 
         if ((tempMonthUrl = calendarParams.computeNextMonthURL(context)) != "") {
-            tempMonthUrl = "<a href=\"" + tempMonthUrl + "\">&gt;</a>";
+            tempMonthUrl = "<a href=\"" + tempMonthUrl + "\">" + msgNextMonth + "</a>";
         } else {
-            tempMonthUrl = "<span class=\"disabled\">&gt</span>";
+            tempMonthUrl = "<span class=\"disabled\">" + msgNextMonth + "</span>";
         }
-        output.append("<th class=\"wiki-calendar-month-nav next-month\">" + tempMonthUrl
-            + "</th>");
+        output.append("<th class=\"wiki-calendar-month-nav next-month\">" + tempMonthUrl + "</th>");
 
         output.append("</tr>");
 
@@ -216,8 +216,7 @@
         }
         output.append("</tr>");
         int weeks =
-            (int) Math.ceil((dayCal.getActualMaximum(Calendar.DAY_OF_MONTH) + (dayCal
-                .get(Calendar.DAY_OF_WEEK)
+            (int) Math.ceil((dayCal.getActualMaximum(Calendar.DAY_OF_MONTH) + (dayCal.get(Calendar.DAY_OF_WEEK)
                 - dayCal.getFirstDayOfWeek() + 7) % 7) / 7.0);
         for (int w = 0; w < weeks; w++) {
             output.append("<tr>");
@@ -227,9 +226,8 @@
 
                 if (script == null)
                     content =
-                        calendarData.getContent(cal, (String) calendarParams.get("user"),
-                            (String) calendarParams.get("location"), (List) calendarParams
-                                .get("categories"), context);
+                        calendarData.getContent(cal, (String) calendarParams.get("user"), (String) calendarParams
+                            .get("location"), (List) calendarParams.get("categories"), context);
                 else
                     content = calendarData.getContent(cal, script, context);
 
@@ -237,8 +235,7 @@
                 ((cal.get(Calendar.DAY_OF_MONTH) == todayCal.get(Calendar.DAY_OF_MONTH))
                     && (cal.get(Calendar.MONTH) == todayCal.get(Calendar.MONTH))
                     && (cal.get(Calendar.YEAR) == todayCal.get(Calendar.YEAR))) {
-                    printDay(output, cal, content, true, cal.get(Calendar.MONTH) == dayCal
-                        .get(Calendar.MONTH));
+                    printDay(output, cal, content, true, cal.get(Calendar.MONTH) == dayCal.get(Calendar.MONTH));
                 } else if // day is in calendar month
                 ((cal.get(Calendar.MONTH) == dayCal.get(Calendar.MONTH))
                     && (cal.get(Calendar.YEAR) == dayCal.get(Calendar.YEAR))) {
@@ -256,17 +253,15 @@
 
         /*
          * output.append("<tr class=\"wiki-calendar-nextprev\">"); output.append("<td colspan=\"7\" align=\"center\">");
-         * output.append("<a href=\""+ calendarParams.computeTodayMonthUrl() +"\"
-         * class=\"wiki-calendar-navbar\">" + msg.get("calendar.today") +"</a>"); output.append("</td>");
-         * output.append("</tr>");
+         * output.append("<a href=\""+ calendarParams.computeTodayMonthUrl() +"\" class=\"wiki-calendar-navbar\">" +
+         * msg.get("calendar.today") +"</a>"); output.append("</td>"); output.append("</tr>");
          */
 
         output.append("</table>");
         return output.toString();
     }
 
-    private void printDay(StringBuffer output, Calendar cal, String content,
-        boolean today, boolean inThisMonth)
+    private void printDay(StringBuffer output, Calendar cal, String content, boolean today, boolean inThisMonth)
     {
         if (inThisMonth) {
             if (today) {
@@ -281,8 +276,8 @@
                 output.append("<td class=\"wiki-calendar-daynotinmonth\">");
             }
         }
-       
-        String classname = "wiki-calendar-daytitle"; 
+
+        String classname = "wiki-calendar-daytitle";
         if (content != null && content.length() > 0) {
             classname += " wiki-calendar-daytitle-hasevent";
         }
@@ -296,9 +291,8 @@
     }
 
     /**
-     * Helper method to build the names of the weekdays. This used to take place in the
-     * <code>CalendarTag</code> constructor, but there, <code>mLocale</code> doesn't have the
-     * correct value yet.
+     * Helper method to build the names of the weekdays. This used to take place in the <code>CalendarTag</code>
+     * constructor, but there, <code>mLocale</code> doesn't have the correct value yet.
      */
     private String[] buildDayNames(Locale locale)
     {
@@ -343,8 +337,8 @@
         return new CalendarPluginApi((CalendarPlugin) plugin, context);
     }
 
-    public net.fortuna.ical4j.model.Calendar getCalendar(String surl, XWikiContext context)
-        throws ParserException, IOException
+    public net.fortuna.ical4j.model.Calendar getCalendar(String surl, XWikiContext context) throws ParserException,
+        IOException
     {
         CalendarBuilder builder = new CalendarBuilder();
         String sical = context.getWiki().getURLContent(surl, context);
@@ -353,8 +347,8 @@
         return calendar;
     }
 
-    public net.fortuna.ical4j.model.Calendar getCalendar(String surl, String username,
-        String password, XWikiContext context) throws ParserException, IOException
+    public net.fortuna.ical4j.model.Calendar getCalendar(String surl, String username, String password,
+        XWikiContext context) throws ParserException, IOException
     {
         CalendarBuilder builder = new CalendarBuilder();
         String sical = context.getWiki().getURLContent(surl, username, password, context);