Index: src/main/resources/colibri/edit.vm
===================================================================
--- src/main/resources/colibri/edit.vm	(revision 26304)
+++ src/main/resources/colibri/edit.vm	(working copy)
@@ -69,14 +69,8 @@
   #template("editmenu.vm")
   </div>
   <div id="mainEditArea">
-  #template("hierarchy.vm")
   #if($editor == "wiki" || $editor == "wysiwyg")
-    #set($docTitle = $request.getParameter("title"))
-    #if("$!docTitle" == "")
-      #set($docTitle = $!tdoc.title)
-    #end
-    <label>$msg.get("titlefield"):
-    <input type="text" id="xwikidoctitleinput" name="title" value="$xwiki.getXMLEncoded("$!docTitle")"/></label>
+    #template("editmeta.vm")
   #end
   #template("editmodes.vm")
   #template("edit${editor}.vm")
Index: src/main/resources/colibri/editactions.vm
===================================================================
--- src/main/resources/colibri/editactions.vm	(revision 0)
+++ src/main/resources/colibri/editactions.vm	(revision 0)
@@ -0,0 +1,28 @@
+### Buttons displayed in the edit interface: cancel, preview (when enabled), save and continue, save and view.
+###
+#if("$!showactions" != '0')
+  #set($keyboardShortcutsEnabled = ($editor!="wysiwyg"))
+  ## This allows the preview form to redirect back to the correct editor when pressing "Back to edit":
+  <div class="versionmeta">
+  <input type="hidden" name="xeditaction" value="$!context.action"/>
+  #if((!$commentFieldAdded)&&($xwiki.hasEditComment()))
+    #set($commentFieldAdded = 1)
+    #if($xwiki.isEditCommentFieldHidden())
+      <input type="hidden" name="comment" value="$!{request.comment}" />
+    #else
+      <div class="versioncommentmeta"><span>$msg.get("core.comment.prompt")</span><input type="text" name="comment" value="$!{request.comment}" size="40" title="Enter a brief description of the modification" /></div>
+    #end
+  #end
+  #if((!$tdoc.isNew()) && (!$minorFieldAdded) && ($xwiki.hasMinorEdit()))
+    #set($minorFieldAdded = 1)
+    <div class="minoreditmeta"><span>$msg.get("core.minoredit")</span><input type="checkbox" name="minorEdit" #if($request.minorEdit)checked="checked" #end/></div>
+  #end
+  <div class="clearfloats"></div>
+  </div> ## metamodifs
+  <div class="buttons">
+    #if($previewenabled) #editActionButton('preview', 'preview') #end
+    #editActionButton('saveandcontinue', 'saveandcontinue')
+    #editActionButton($saveaction, 'saveandview')
+    #editActionButton('cancel', 'cancel')
+  </div> ## buttons
+#end
Index: src/main/resources/colibri/colibri.css
===================================================================
--- src/main/resources/colibri/colibri.css	(revision 26304)
+++ src/main/resources/colibri/colibri.css	(working copy)
@@ -619,19 +619,60 @@
   *  Layout elements for Colibri skin in edit mode
 -------------------------------------------------------------- */
 .alleditcontent {
-  margin: 0 225px 25px 20px;
+  margin: 0 25px 25px 20px;
 }
 
-.alleditcontent label, .metamodifs {
-  display: block;
+.alleditcontent label, .versionmeta {
   font-size: .85em;
   font-weight: 700;
-  margin: 10px 0;
   text-transform: uppercase;
 }
 
-#xwikidoctitleinput, .metamodifs input[type="text"] {
-  width: 99.8%;
+.versionmeta {
+  margin-top: 10px;
+  width: 100%;
+}
+
+.minoreditmeta, .versioncommentmeta {
+  float: left;
+}
+
+.versioncommentmeta {
+  width: 50%;
+}
+
+.versioncommentmeta input {
+  width: 97%;
+}
+
+.versionmeta span {
+  display: block;
+}
+
+.alleditcontent #titleinput {
+  float: left;
+  width: 50%;
+}
+
+.alleditcontent #titleinput input {
+  width: 97%;
+}
+
+.alleditcontent #languageinput, .alleditcontent #parentinput, .alleditcontent #syntaxinput {
+  float: right;
+  width: 14%;
+}
+
+.alleditcontent #languageinput select, .alleditcontent #parentinput input, .alleditcontent #syntaxinput select {
+  width: 96%;
+}
+
+.alleditcontent #meta dt {
+  margin-top: 0;
+}
+
+.alleditcontent #meta {
+  margin-bottom: 10px;
 }
 
 .inlinebody dt {
@@ -639,6 +680,11 @@
   text-transform: uppercase;
 }
 
+#usersandgroupstable {
+  margin-top: 10px;
+  margin-bottom: 20px;
+}
+
 /* @group EDITORS  */
 /* --------------------------------------------------------------
   * These classes should be moved in proper editor css files
@@ -1657,14 +1703,6 @@
   color: $theme.titleColor;
 }
 
-/* @group BLOG  */
-/* --------------------------------------------------------------
-  * These classes should be moved in BlogStyle ssx file
--------------------------------------------------------------- */
-input#tags {
-  width: 99.8%;
-}
-
 /* @group OTHER  */
 /* --------------------------------------------------------------
   * These classes should be moved in their specific files
Index: src/main/resources/colibri/editpanelsvars.vm
===================================================================
--- src/main/resources/colibri/editpanelsvars.vm	(revision 26304)
+++ src/main/resources/colibri/editpanelsvars.vm	(working copy)
@@ -1,7 +1,7 @@
 ## Define variables containing the list of edit panels for the Toucan skin
-#set($editorPanelsWysiwyg = "Panels.DocumentInformation,Panels.EditTranslations,Panels.SyntaxHelp")
-#set($editorPanelsWiki = "Panels.DocumentInformation,Panels.EditTranslations,Panels.SyntaxHelp")
+#set($editorPanelsWysiwyg = "")
+#set($editorPanelsWiki = "")
 #set($editorPanelsObjects = "Panels.ObjectEditorWelcome,Panels.AddObject")
 #set($editorPanelsClass = "Panels.AddClassProperty,Panels.ClassSwitcher")
-#set($editorPanelsRights = "Panels.RightsEditorWelcome,Panels.RightsTips")
+#set($editorPanelsRights = "")
 #set($editorPanelsHistory = "")
\ No newline at end of file
Index: src/main/resources/colibri/editmeta.vm
===================================================================
--- src/main/resources/colibri/editmeta.vm	(revision 0)
+++ src/main/resources/colibri/editmeta.vm	(revision 0)
@@ -0,0 +1,63 @@
+#set($docTitle = $request.getParameter('title'))
+#if("$!docTitle" == '')
+  #set($docTitle = $!tdoc.title)
+#end
+<div id="meta">
+  <div id="titleinput">
+      <label for="xwikidoctitleinput">$msg.get('titlefield')</label>
+      <input type="text" id="xwikidoctitleinput" name="title" value="$xwiki.getXMLEncoded("$!docTitle")"/>
+  </div>
+  <div id="parentinput">
+    <label for="xwikidocparentinput2">$msg.get('parentfield')</label></dt>
+    <input type="text" id="xwikidocparentinput2" name="parent" value="$!tdoc.parent" size="30"/>
+  </div>
+  ## TODO: move the syntax converter jsx outside of the panel, in XWiki.XWikiSyntax for example.
+  $xwiki.jsx.use("Panels.DocumentInformation")##
+  <div id="syntaxinput">
+    <label for="xwikidocsyntaxinput2">$msg.get('Syntax')</label>
+    <select name="syntaxId" id="xwikidocsyntaxinput2">
+      <option value="xwiki/1.0"#if($tdoc.getSyntaxId().equalsIgnoreCase('xwiki/1.0')) selected="selected"#end>XWiki 1.0</option>
+      #set($configuredSyntaxes = $xwiki.getConfiguredSyntaxes())
+      #foreach($syntax in $syntaxFactory.getAvailableSyntaxes())
+        #if($configuredSyntaxes.contains($syntax.toIdString()) && !$syntax.toIdString().equalsIgnoreCase('xwiki/1.0'))
+          <option value="$syntax.toIdString()"#if($tdoc.getSyntaxId().equalsIgnoreCase($syntax.toIdString()))selected="selected"#end>$syntax.toString()</option>
+        #end  
+      #end
+    </select>
+  </div>
+  #set($availLangs = $xwiki.getXWikiPreference("languages").split("[|, ]"))
+  #set($defaultLang = $doc.defaultLanguage)
+  #set($langMap = $util.getHashMap())
+  #foreach($lang in $availLangs)
+    #set($discard = $langMap.put($msg.get("core.language.${lang}"), $lang))
+  #end
+  #set($discard = $sorttool.sort($langMap))
+  #if(($request.language)&&($request.language!="default")&&($doc.defaultLanguage!=$request.language))
+    #set($forcedLang = $request.language)
+    #set($currentLang = $request.language)
+  #else
+    #set($forcedLang = "")
+    #set($currentLang = $doc.language)
+  #end  
+  <div id="languageinput">
+    <label for="languageswitcher">Language</label>
+    <select id="languageswitcher">
+      #foreach($lang in $langMap.keySet())
+        #set($langId = $langMap.get($lang))
+        <option id="$langId" value="$langId" #if($currentLang==$langId)selected='selected'#end>$lang#if($langId==$defaultLang) $msg.get('core.language.default')#end</option>
+      #end
+    </select>
+    #set($baseediturl = $doc.getURL("edit", "editor=${editor}&language="))
+    <script type="text/javascript">
+      //<![CDATA[
+        Event.observe('languageswitcher', 'change', function(event) {
+          var baseediturl = "$baseediturl";
+          if (confirm("$msg.get('core.language.confirmswitch')")) {
+            window.location = baseediturl + $('languageswitcher').value;
+          }
+        });
+      //]]>      
+    </script>
+  </div>
+  <div class="clearfloats"></div>
+</div>
\ No newline at end of file